Attribute VB_Name = "Modul2"
Option Explicit
Private Function wandle_in_Double_um(ByVal eingabe As String, rueckgabe As Double) _
                    As Boolean
    wandle_in_Double_um = True
    If Not IsNumeric(eingabe) Then
        MsgBox ("Der von Ihnen eingegebene Wert mu eine Zahl sein! ")
        wandle_in_Double_um = False
        Exit Function
    End If
    rueckgabe = CDbl(eingabe)
End Function
Private Function Lies_und_ueberpruefe_Benutzereingaben(ByVal immobilienpreisString As String, _
                                                        ByVal eigenkapitalString As String, _
                                                        ByVal tilgungString As String, _
                                                        immobilienpreis As Double, _
                                                        eigenkapital As Double, _
                                                        tilgung As Double) _
                                                        As Boolean
                                    
        Lies_und_ueberpruefe_Benutzereingaben = True
        If Not wandle_in_Double_um(immobilienpreisString, immobilienpreis) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            Exit Function
        End If
        If Not wandle_in_Double_um(eigenkapitalString, eigenkapital) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            Exit Function
        End If
        If Not wandle_in_Double_um(tilgungString, tilgung) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            Exit Function
        End If
End Function
Function monatlicheBelastungBerechnen(ByVal preis As Double, _
                                            ByVal eigenkapital As Double, _
                                            ByVal zins As Double, _
                                            ByVal tilgung As Double) _
                                                As Double
    Dim kreditbetrag As Double
    Dim jahresBelastung As Double
    kreditbetrag = preis - eigenkapital
    jahresBelastung = kreditbetrag * (zins + tilgung) / 100
    monatlicheBelastungBerechnen = jahresBelastung / 12
End Function
Function eigenkapitalQuoteBerechnen(eigenkapital As Double, _
                                        preis As Double) As Double
    eigenkapitalQuoteBerechnen = (eigenkapital / preis) * 100
End Function
Function bank(immobilienpreisString As String, _
                eigenkapitalString As String, _
                tilgungString As String) _
                As Variant
    Dim eigenkapital As Double
    Dim immobilienpreis As Double
    Dim tilgung As Double
    Dim monatlicheBelastung As Double
    Dim eigenkapitalQuote As Double
    Const zins As Double = 8.5
    If Not Lies_und_ueberpruefe_Benutzereingaben(immobilienpreisString, eigenkapitalString, _
                    tilgungString, immobilienpreis, eigenkapital, tilgung) Then Exit Function
    eigenkapitalQuote = eigenkapitalQuoteBerechnen(eigenkapital, immobilienpreis)
    If eigenkapitalQuote < 30 Then
        MsgBox ("Ihre Eigenkapitalquote ist zu niedrig, sie " & Chr$(13) & _
                "betrgt nur: " & eigenkapitalQuote & "%")
        bank = "Nicht berechnet"
    Else
        bank = monatlicheBelastungBerechnen(immobilienpreis, eigenkapital, zins, tilgung)
    End If
End Function
