VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} Zinsberechnung 
   Caption         =   "Zinsberechnung"
   ClientHeight    =   2235
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4560
   OleObjectBlob   =   "BankEinfachFormularGemischt2.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "Zinsberechnung"
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub BerechnenButton_Click()
    Dim eigenkapital As Double
    Dim immobilienpreis As Double
    Dim tilgung As Double
    Dim monatlicheBelastung As Double
    Dim eigenkapitalQuote As Double
    Const zins As Double = 8.5
    Dim immobilienpreisString As String
    Dim eigenkapitalString As String
    Dim tilgungString As String
    
    immobilienpreisString = ImmobilienpreisInput.Text
    eigenkapitalString = EigenkapitalInput.Text
    tilgungString = TilgungInput.Text
    
    If Not Lies_und_ueberpruefe_Benutzereingaben(immobilienpreisString, eigenkapitalString, _
                    tilgungString, immobilienpreis, eigenkapital, tilgung) Then Exit Sub
    eigenkapitalQuote = eigenkapitalQuoteBerechnen(eigenkapital, immobilienpreis)
    If eigenkapitalQuote < 30 Then
        MsgBox ("Ihre Eigenkapitalquote ist zu niedrig, sie " & Chr$(13) & _
                "betrgt nur: " & eigenkapitalQuote & "%")
        Cells(1, 1) = "Ihre monatliche Belastung konnte nicht berechnet werden!"
    Else
        Cells(1, 1) = "mon. Belastung"
        Cells(1, 2) = monatlicheBelastungBerechnen(immobilienpreis, eigenkapital, zins, tilgung)
    End If
    Unload Me
End Sub

Private Function wandle_in_Double_um(ByVal eingabe As String, rueckgabe As Double) _
                    As Boolean
    wandle_in_Double_um = True
    If Not IsNumeric(eingabe) Then
        MsgBox ("Der von Ihnen eingegebene Wert mu eine Zahl sein! ")
        wandle_in_Double_um = False
        Exit Function
    End If
    rueckgabe = CDbl(eingabe)
End Function

Private Function Lies_und_ueberpruefe_Benutzereingaben(immobilienpreisString As String, _
                                                        eigenkapitalString As String, _
                                                        tilgungString As String, _
                                                        immobilienpreis As Double, _
                                                        eigenkapital As Double, _
                                                        tilgung As Double) _
                                                        As Boolean
                                    
        Lies_und_ueberpruefe_Benutzereingaben = True
        If Not wandle_in_Double_um(immobilienpreisString, immobilienpreis) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            MsgBox ("Immobilienpreis muss eine Zahl sein!")
            ImmobilienpreisInput.SetFocus
            Exit Function
        End If
        If Not wandle_in_Double_um(eigenkapitalString, eigenkapital) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            MsgBox ("Eigenkapital muss eine Zahl sein!")
            EigenkapitalInput.SetFocus
            Exit Function
        End If
        If Not wandle_in_Double_um(tilgungString, tilgung) Then
            Lies_und_ueberpruefe_Benutzereingaben = False
            MsgBox ("Tilgung muss eine Zahl sein!")
            TilgungInput.SetFocus
            Exit Function
        End If
End Function
Function monatlicheBelastungBerechnen(ByVal preis As Double, _
                                            ByVal eigenkapital As Double, _
                                            ByVal zins As Double, _
                                            ByVal tilgung As Double) _
                                                As Double
    Dim kreditbetrag As Double
    Dim jahresBelastung As Double
    kreditbetrag = preis - eigenkapital
    jahresBelastung = kreditbetrag * (zins + tilgung) / 100
    monatlicheBelastungBerechnen = jahresBelastung / 12
End Function
Function eigenkapitalQuoteBerechnen(eigenkapital As Double, _
                                        preis As Double) As Double
    eigenkapitalQuoteBerechnen = (eigenkapital / preis) * 100
End Function


